﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


//------------------------------------------------------------
public class CoffeeCupBehaviour : MonoBehaviour
{
    public Material coffeeMaterial;
    public Material milkMaterial;
    public Material latteMaterial;
    public Material mochaMaterial;
    public Material teaMaterial;
    public bool m_isFilled = false;
    public eDrinkType m_filledWith = eDrinkType.NONE;
    public GameObject m_filledMesh;
    public GameObject m_emptyMesh;
    public GameObject m_coffeeMesh;


    //------------------------------------------------------------
    void Start ()
    {

	}


    //------------------------------------------------------------
    void Update ()
    {
		
	}


    //------------------------------------------------------------
    public void Fill(eDrinkType drinkType)
    {
        if(!m_isFilled)
        {
            m_isFilled = true;
            m_filledWith = drinkType;
            m_filledMesh.SetActive(true);
            m_emptyMesh.SetActive(false);

            SetLiquidMaterial();

            GameManager.instance.PlayRandomPour();
        }
    }


    void SetLiquidMaterial()
    {
        switch(m_filledWith)
        {
            case eDrinkType.COFFEE:
                m_coffeeMesh.GetComponent<MeshRenderer>().material = coffeeMaterial;
                break;
            case eDrinkType.LATTE:
                m_coffeeMesh.GetComponent<MeshRenderer>().material = latteMaterial;
                break;
            case eDrinkType.MILK:
                m_coffeeMesh.GetComponent<MeshRenderer>().material = milkMaterial;
                break;
            case eDrinkType.MOCHA:
                m_coffeeMesh.GetComponent<MeshRenderer>().material = mochaMaterial;
                break;
            case eDrinkType.TEA:
                m_coffeeMesh.GetComponent<MeshRenderer>().material = teaMaterial;
                break;
        }
    }
}
