﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


//------------------------------------------------------------
public class CoffeeDispenserBehaviour : MonoBehaviour
{
    public eDrinkType m_drinkType;
    public ParticleSystem m_pouringDrink;

    void Start()
    {
        m_pouringDrink.Stop();
    }

    //------------------------------------------------------------
    void OnTriggerEnter(Collider other)
    {
        GameObject cup = other.gameObject;
        CoffeeCupBehaviour cupBehaviour = cup.GetComponent<CoffeeCupBehaviour>();
        if (cupBehaviour)
        {
            cupBehaviour.Fill(m_drinkType);
        }

        m_pouringDrink.Play();
    }


    //------------------------------------------------------------
    void OnTriggerExit(Collider other)
    {
        m_pouringDrink.Stop();
    }
}
